// --------------------------------------------------------
// Code generated by Papyrus Java
// --------------------------------------------------------

package statemachineJava;

import SimpleSMJava.SimpleSM;
import java.util.concurrent.Semaphore;

/************************************************************/
/**
 * 
 */
public class StructForThread_t extends Thread {
	/**
	 * 
	 */
	public int id;
	/**
	 * 
	 */
	public char enter_mode;
	/**
	 * 
	 */
	public ThreadFunctions func_type;
	/**
	 * 
	 */
	public int duration;
	/**
	 * 
	 */
	public Semaphore sem;
	/**
	 * 
	 */
	public SimpleSM sm;

	/**
	 * 
	 * @param sm 
	 * @param func_type 
	 * @param id 
	 * @param sem 
	 */
	public StructForThread_t(SimpleSM sm, ThreadFunctions func_type, int id, Semaphore sem) {
		this.sm = sm;
		this.sem = sem;
		this.id = id;
		this.func_type = func_type;
	}

	/**
	 * 
	 */
	public void run() {
		switch (func_type) {
		case TF_DO_ACTIVITY:
			sm.doCallActivity(id);
			break;
		case TF_TIME_EVENT:
			sm.listenTimeEvent(sm.getTEIndex(id), duration);
			break;
		case TF_STATE_MACHINE_TYPE:
			sm.dispatchEvent();
			break;
		default:
			// do nothing
			break;
		}
	}

	/**
	 * 
	 * @param sm 
	 * @param id 
	 * @param func_type 
	 */
	public StructForThread_t(SimpleSM sm, int id, ThreadFunctions func_type) {
		this.sm = sm;
		this.id = id;
		this.func_type = func_type;
	}
}
